package com.cogentlogic.training.android.crypto;

import java.security.Key;
import java.security.SecureRandom;
import java.security.Security;

import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

import org.spongycastle.jce.provider.BouncyCastleProvider;

import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;

public class MainActivity extends Activity
{
	static
	{
		Security.addProvider(new BouncyCastleProvider());
	}

	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

        try
        {
        	String strImportedIV = "CCFC9FAB222D3B9E70141677B80AA084";
        	String strImportedKey = "C1EAC0B437A7FBD101AD95E3D9FB4D0D41EB0504097EC96618470EBC362417A1";
        	String strImportedEncryptedMessage = "64B7375EA964B3105DA1193B91FB2AB031DDC81AC162769F9486A7A2229754166EA237F69880268984575B66DD2D285B";

			byte[] bytesIV = Utilities.toData(strImportedIV);
			IvParameterSpec iv = new IvParameterSpec(bytesIV);

			Key key256AES = new SecretKeySpec(Utilities.toData(strImportedKey), "AES");

			byte[] cipherText = Utilities.toData(strImportedEncryptedMessage);

			Cipher cipher = Cipher.getInstance("AES/CBC/PKCS7Padding", "SC");		// CBC requires an initialization vector

			// Decrypt
	        byte[] bytesDecryptedText = new byte[cipherText.length];				// the decrypted text cannot be longer than the cipher data
	        cipher.init(Cipher.DECRYPT_MODE, key256AES, iv);
	        int nDecryptedTextLen = cipher.update(cipherText, 0, cipherText.length, bytesDecryptedText, 0);
	        nDecryptedTextLen += cipher.doFinal(bytesDecryptedText, nDecryptedTextLen);
	        String strDecryptedText = new String(bytesDecryptedText, 0, nDecryptedTextLen, "UTF-8");
	        System.out.println("Decrypted text: " + strDecryptedText);
        }
        catch (Exception except)
        {
        	except.printStackTrace();
        }
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	public static class Utilities
	{
		private static final String s_strHexDigits = "0123456789ABCDEF";

		public static String toHex(byte[] dataIn)
		{
			StringBuffer sbOut = new StringBuffer();
			for (int n=0; n<dataIn.length; n++)
			{
				sbOut.append(s_strHexDigits.charAt((dataIn[n] >> 4) & 0xF));	// high nybble
				sbOut.append(s_strHexDigits.charAt(dataIn[n] & 0xF));			// low nybble
			}
			return sbOut.toString();
		}


		public static byte[] toData(String strIn)
		{
			int nLen = strIn.length();
			byte[] bytesOut = new byte[nLen / 2];		// two hex digits -> one byte
			for (int n=0; n<nLen; n+=2)
				bytesOut[n/2] = (byte)((Character.digit(strIn.charAt(n), 16) << 4) + Character.digit(strIn.charAt(n+1), 16));
			return bytesOut;
		}
	}
}
